# JointSU Class 1.0  2009.Jan.26   by   Marcio de A. Braga
# 
require 'sketchup.rb'
include Math

class JointSU
def initialize #1 << entra J1 e << sai C1 >> se nao inicializada ou << sai C2 >> se inicializada
	@junta1=nil
	@junta2=nil
	@compo1=nil
	@compo2=nil
	@jointSU_ok=false
	@var1=1.0.mm
	@var2=PI/180.0
	@turbo1=20.0
	@turbo2=15.0
	@t1=nil
	@t2=nil
	@t3=nil
	@t4=nil
	@t5=nil
	@precision=0.0001
	@pickStatus=nil
	pick=Sketchup.active_model.selection[0] # assume there is a selection to call this class
	path=Sketchup.active_model.active_path # path no nivel de J1
	if path == nil # JointSU not at MODEL level
		@pickStatus=4
	else
		@pickStatus=type(pick)
		# 0 = pick is not a Compo Instance
		# 1 = pick is JointSU
		# 2 = pick is a Compo Instance but not a JointSU
		# 3 = pick is a JointSU without name
		if @pickStatus==1 # pick is JointSU
			@junta1=pick
			@compo1=path[-1]
			@compo2=path[-2] if path.size>1
			@jointSU_ok=setJ2_fromDictionary # se J2 ja estiver definida
			Sketchup.active_model.close_active # << entra J1 sai C1 >>
			Sketchup.active_model.close_active if isConnected? # << entra C1 sai C2 >> se conectada
		end # sai C1 ou C2 depende se conectada ou nao ...
	end
end
def status
	# 0 = J1 connected with J2 and aligned
	# 1 = J1 connected with J2 but not aligned
	# 2 = J1 not connected with J2
	# 3 = J1 has no name
	# 4 = J1 at Model level
	# 5 = J2 has no name
	# 99 = J1 is not a JointSU
	if @pickStatus==1 # there is a J1
		return 3 if @junta1.name==""
		if @junta2 == nil
			return 2
		else
			return 5 if @junta2.name==""
			r1=getJ1parms_fromDictionary
			return 2 if r1==nil
			r2=getJ1parms_fromModel
			return 1 if (r1[0]-r2[0]).abs>@precision or r1[3] != r2[3] or (r1[1]-r2[1]).abs>@precision
			#return 1 if (r1[1].abs-PI).abs<@precision and (r2[1].abs-PI).abs<@precision
			return 0
		end
	else
		return 3 if @pickStatus==3
		return 4 if @pickStatus==4
		return 99
	end
end

def type(pick) # << entra X sai X >> retorna 1 caso pick seja uma JointSU, 2 caso Compo ou 0 se nada disso
	# 0 = not a Compo Instance
	# 1 = JointSU
	# 2 = Compo Instance but not a JointSU
	# 3 = JointSU without name
	return 0 if pick.typename != "ComponentInstance"
	return 2 if pick.definition.name != "JointSU"
	return 3 if pick.name==""
	return 1
end
def isValid?
	return true if @junta1 !=nil
	return false
	end
def isConnected?
	return false if @jointSU_ok==false
	return false if @junta1==nil or @junta2==nil or @compo1==nil or @compo2==nil
	return false if getJ1parms_fromDictionary==nil
	return true
end
def isAligned?
	r1=getJ1parms_fromDictionary
	r2=getJ1parms_fromModel
	return false if (r1[0]-r2[0]).abs>@precision or r1[3] != r2[3]
	return true if (r1[1].abs-PI).abs<@precision and (r2[1].abs-PI).abs<@precision
	return false if (r1[1]-r2[1]).abs>@precision
	return true
end
def deleteConnection
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	if d !=nil
		@compo1.delete_attribute("JointSU#{@junta1.name}")
	end
end
def checkDictionary
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	if d !=nil
		d["Translation"]=0.0 if "#{d["Translation"].class}"=="NilClass" 
		d["Rotation"]=0.0 if d["Rotation"]==nil
		d["Flip"]=false if d["Flip"] != true and d["Flip"] != false
		d["Animation"]=false if d["Animation"] != true and d["Animation"] != false
		d["Step"]=0.0 if d["Step"]==nil
	end
end

def setJ2_fromDictionary #4 << entra X sai X >> return JointSU - prereq: Compo1 & Compo2
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	return false if d == nil # Compo1 nao tem Dictionary ... precisa ir via Pick
	if @compo2==nil then
		compo2Entities=Sketchup.active_model.entities
	else
		compo2Entities=@compo2.definition.entities
	end
	compo2Entities.each do |joint|
		if joint.typename=="ComponentInstance" then
			if joint.definition.name=="JointSU" then
				if joint.name==d["Joint2"]
					@junta2=joint
					return true
				end
			end
		end
	end
	return false # nao achou ...
	end #def
def setJ2_fromPick(pick) # ToolSet << entra C1 sai C2 se OK ou sai C1 se KO >>
	# 0 = not a Compo Instance
	# 1 = JointSU
	# 2 = Compo Instance but not a JointSU
	# 3 = JointSU without name
	r=type(pick)
	if r==1 # posiciona em C2
		@junta2=pick # ok, pegou a J2. Agora pode ir para o nivel C2
		# set new dict if not exist, otherwise, just update Joint2
		@compo1.set_attribute("JointSU#{@junta1.name}","Joint2",@junta2.name)
		Sketchup.active_model.close_active # posicionado em C2
		@jointSU_ok=true
		setTransformations(false)
	end
	return r
end
def setTransformations(turbo) #7 [prereq] estar em C2
	t_J2C2=@junta2.transformation # transf da J2 em relacao a C2 (prereq: estar em C2)
	v=t_J2C2.xaxis.clone
	if turbo
		v.length=@turbo1*@var1
		angulo=@turbo2*@var2
	else
		v.length=@var1
		angulo=@var2
	end
	@t1=Geom::Transformation.translation(v) # translacao positiva
	@t2=Geom::Transformation.translation(v.reverse) # translacao negativa
	@t3=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.xaxis,angulo) # torcao positiva
	@t4=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.xaxis,-angulo) # torcao negativa	
	@t5=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.zaxis,PI) # flip		
end
def getJ1parms_fromModel # ToolHandle << entra C2 sai C2 >>
	t_J1C1=@junta1.transformation # transf da J1 em relacao a C1
	t_C1C2=@compo1.transformation # transf da C1 em relacao a C2
	t_J2C2=@junta2.transformation # transf da J2 em relacao a C2
	t_C2J2=t_J2C2.inverse # esta transformacao  para medir os valores de J1 em relacao a J2
	flip=false
	flip=true if ((t_C2J2 * t_C1C2 * t_J1C1).xaxis).x<0.0
	delta=(t_C2J2 * t_C1C2 * t_J1C1.origin).x
	coseno=(t_C2J2 * t_C1C2 * t_J1C1.yaxis).normalize.y # t_C1C2 is not normalized !!! SketchUP error ??
	coseno=1.0 if coseno>1.0 # to fix case cos=1.0001
	coseno=-1.0 if coseno<-1.0 # to fix case cos=-1.0001
	coseno=-coseno if flip
	alfa=acos(coseno)
	alfa=-alfa if (t_C2J2 * t_C1C2 * t_J1C1.yaxis).z <0.0
	alfa=PI if alfa<-PI+@precision
	[delta,alfa,flip]
end

def getJ1parms_fromDictionary # << entra J1 sai J1 >>
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	return nil if d==nil # No dictionary on Joint
	return nil if d["Joint2"] != @junta2.name 
	return nil if "#{d["Translation"].class}"=="NilClass" 
	return nil if d["Rotation"]== nil
	return nil if d["Flip"] != true and d["Flip"] != false
	return [d["Translation"],d["Rotation"],d["Flip"],d["Animation"],d["Step"]]
end
def getParentComponents
	[@junta2,@compo2,@compo1]
end
	
def setJ1parms_toDictionary(r) # Align << entra X sai X >>
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	if d !=nil
		r[0]=0.0 if r[0].abs<@precision
		d["Translation"]=r[0]
		r[1]=0.0 if r[1].abs<@precision
		d["Rotation"]=r[1]
		d["Flip"]=r[2]
		@jointSU_ok=true
	else
		@jointSU_ok=false
	end
	@jointSU_ok
end
def setJ1parmsAnime_toDictionary(r)
	d=@compo1.attribute_dictionary("JointSU#{@junta1.name}")
	return false if d==nil # No dictionary on Joint
	d["Animation"]=r[0]
	d["Step"]=r[1]	
	return true
end

def execTransformation(tipo)
	if tipo=="delta+"
		@compo1.transform!(@t1)
	elsif tipo=="delta-"
		@compo1.transform!(@t2)
	elsif tipo=="alpha+"
		@compo1.transform!(@t3)
	elsif tipo=="alpha-"
		@compo1.transform!(@t4)
	elsif tipo=="flip"
		t_J1C1=@junta1.transformation # transf da J1 em relacao a C1
		t_J2C2=@junta2.transformation # transf da J2 em relacao a C2
		t_C2J2=t_J2C2.inverse # esta transformacao  para medir os valores de J1 em relacao a J2
		t_C1C2=@compo1.transformation # transf da C1 em relacao a C2
		ptX=(t_C2J2 * t_C1C2 * t_J1C1.origin).x
		v=t_J2C2.xaxis.clone
		v.length=2.0*ptX
		t6=Geom::Transformation.translation(v)
		@compo1.transform!(@t5) # flip	
		@compo1.transform!(t6)
	end
	end
def alignJ1(r) # ToolSet << entra C2 sai C2 >> posiciona J1(parms) em relacao a J2
	delta=r[0] # translacao em inches
	alfa=r[1] # rotacao em radians
	flip=r[2]
	M1.alignC1(@compo1, @junta1, @junta2, delta,alfa,flip)
end
end # CLASS JointSU

#####################
class CompoSU
def initialize
	pick=Sketchup.active_model.selection[0]
	if isPickValid?(pick)
		@compo1=pick
		@compoSU_ok=true
		Sketchup.active_model.close_active # to position on C1 parent
		@vetorX=Geom::Vector3d.new(1.0, 0.0, 0.0)
		@vetorY=Geom::Vector3d.new(0.0, 1.0, 0.0)
		@vetorZ=Geom::Vector3d.new(0.0, 0.0, 1.0)
		@precision=0.0001
	else
		@compoSU_ok=false
	end
end

def isPickValid?(pick)
	if pick.typename == "ComponentInstance" then
		return true
	else
		return false
	end
end

def isValid?
	@compoSU_ok
end
def getCompo
	@compo1
end
def zeroCompo # also fix problem with Axes
	m=[]
	m[0]=1
	m[1]=0
	m[2]=0
	m[3]=0
	
	m[4]=0
	m[5]=1
	m[6]=0
	m[7]=0
	
	m[8]=0
	m[9]=0
	m[10]=1
	m[11]=0
	
	m[12]=0
	m[13]=0
	m[14]=0
	m[15]=1	
	@compo1.transformation=Geom::Transformation.new(m) 
end

def getAxesError
	M1.checkAxesBase(@compo1)
end

def getAlphaFromVectors(vX,vY) # X/Y orthogonals from an axis system
	x=vX.x
	y=vX.y
	x=0.0 if x.abs<@precision
	y=0.0 if y.abs<@precision
	if x==0.0
		if y==0.0
			alfa=vY.angle_between(@vetorY)
			alfa=-alfa if vY.x>0.0
		else
			alfa=PI/2.0
			alfa=alfa-PI if y<0.0
		end
	else
		alfa=atan(y/x)
		if x<0.0
			alfa=alfa+PI if y>=0.0
			alfa=alfa-PI if y<0.0
		end
	end
	alfa=0.0 if alfa.abs<@precision
	p "PROBLEMA em ALFA" if alfa.abs>PI
	alfa
end

def getBetaFromVector(vX)
	x=vX.x
	y=vX.y
	z=vX.z
	if x.abs<@precision and y.abs<@precision
		beta=PI/2.0
		beta=-beta if z<@precision
	else
		beta=atan(z/sqrt(x*x+y*y))
	end
	beta=0.0 if beta.abs<@precision
	p "PROBLEMA em BETA" if beta.abs>PI/2.0
	beta
end
def getTorsionFromVectors(vX,vY)
	getPolarFromVectors(vX,vY)[2]
end
def getPolarFromVectors(vX,vY) # X/Y orthogonals from an axis system
	alfa=getAlphaFromVectors(vX,vY)
	beta=getBetaFromVector(vX)
	t_Alfa = Geom::Transformation.rotation([0,0,0], @vetorZ, alfa)
	vN=Geom::Vector3d.new(sin(alfa),-cos(alfa),0)
	t_Beta = Geom::Transformation.rotation([0,0,0], vN, beta)
	vX1=@vetorX.clone
	vX1.transform!(t_Alfa)
	vX1.transform!(t_Beta)
	vY1=@vetorY.clone
	vY1.transform!(t_Alfa)
	vY1.transform!(t_Beta)
	# With X1/X2 aligned, calculate Torsion as angle between Y1/Y2
	torsion=vY1.angle_between(vY)
	if torsion.abs<@precision
		torsion=0
	else
		torsion=-1.0*torsion if ((vY1*vY).normalize! == vX1)==false
	end
	[alfa,beta,torsion]
end	

def getOriginFromCompo
	@compo1.transformation.origin
end

def getPolarFromCompo
	getPolarFromVectors(@compo1.transformation.xaxis,@compo1.transformation.yaxis)
end
def getAlphaFromCompo
	getAlphaFromVectors(@compo1.transformation.xaxis,@compo1.transformation.yaxis)
end
def getBetaFromCompo
	getBetaFromVector(@compo1.transformation.xaxis)
end
def getTorsionFromCompo
	getPolarFromVectors(@compo1.transformation.xaxis,@compo1.transformation.yaxis)[2]
end

def addXonCompo(x)
	m=@compo1.transformation.to_a
	m[12]=m[12]+x
	@compo1.transformation=m
	m[12]
end
def addYonCompo(y)
	m=@compo1.transformation.to_a		
	m[13]=m[13]+y
	@compo1.transformation=m
	m[13]
end
def addZonCompo(z)
	m=@compo1.transformation.to_a		
	m[14]=m[14]+z
	@compo1.transformation=m		
	m[14]
end
def addAlphaOnCompo(alfa)
	@compo1.transform!(Geom::Transformation.rotation(@compo1.transformation.origin, @vetorZ, alfa))
	getAlphaFromCompo
end
def addBetaOnCompo(beta)
	alfa=getAlphaFromCompo
	vN=Geom::Vector3d.new(sin(alfa),-cos(alfa),0)
	@compo1.transform!(Geom::Transformation.rotation(@compo1.transformation.origin, vN, beta))
	getBetaFromCompo
end
def addTorsionOnCompo(torsion)
	alfa=getAlphaFromCompo
	beta=getBetaFromCompo
	origem=@compo1.transformation.origin
	vetorAxial=@vetorX.clone
	vetorAxial.transform!(Geom::Transformation.rotation(origem, @vetorZ, alfa))
	vN=Geom::Vector3d.new(sin(alfa),-1.0*cos(alfa),0)
	vetorAxial.transform!(Geom::Transformation.rotation(origem, vN, beta))
	@compo1.transform!(Geom::Transformation.rotation(origem, vetorAxial, torsion))
	getTorsionFromCompo
end
def setCompoOnPolar(origem,alfa,beta,torsion)
	if alfa>=-PI-@precision and alfa<=PI+@precision
		if beta>=-PI/2.0-@precision and beta<=PI/2.0+@precision
			if torsion>=-PI-@precision and torsion<=PI+@precision
				# posicionar x, y, z, alfa=0, beta=0, torsion=0
				@compo1.transformation=Geom::Transformation.new(origem).to_a
				addAlphaOnCompo(alfa) # posicionar em alfa
				addBetaOnCompo(beta) # posicionar em beta
				addTorsionOnCompo(torsion) # posicionar torsion axial
				return true
			end
		end
	end
	false
end

end
####################
module M1
def self.assemble
	while Sketchup.active_model.close_active; end # set path at Model level
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec2(filho,nil)
		end
	end
end
def self.filhosExec2(c1,c2)
	dic_list=c1.attribute_dictionaries
	if dic_list !=nil
		dic_list.each do |d|
			if d.name[0,7]=="JointSU" # if C1 has a dictionary for J1 ...
				delta1=d["Translation"]
				alfa1=d["Rotation"]
				flip1=d["Flip"]
				@j1=nil				
				c1.definition.entities.each do |j|
					if j.typename=="ComponentInstance"
						if j.definition.name=="JointSU"
							if j.name==d.name[7,99]
								@j1=j
								break
							end
						end
					end
				end
				@j2=nil
				j2=false
				c2.definition.entities.each do |j|
					if j.typename=="ComponentInstance"
						if j.definition.name=="JointSU"
							if j.name==d["Joint2"]
								@j2=j
								break
							end
						end
					end
				end
				t_J1C1=@j1.transformation
				t_J2C2=@j2.transformation				
				t_C1C2=c1.transformation
				t_C2J2=t_J2C2.inverse
				flip=false
				flip=true if ((t_C2J2 * t_C1C2 * t_J1C1).xaxis).x<0.0
				delta=(t_C2J2 * t_C1C2 * t_J1C1.origin).x
				coseno=(t_C2J2 * t_C1C2 * t_J1C1.yaxis).y
				coseno=1.0 if coseno>1.0
				coseno=-1.0 if coseno<-1.0
				coseno=-coseno if flip
				alfa=acos(coseno)
				alfa=-alfa if (t_C2J2 * t_C1C2 * t_J1C1.yaxis).z <0.0
				alfa=PI if alfa<-PI+0.0001
				precision=0.0001
				ang=(t_C1C2*t_J1C1.xaxis).angle_between(t_J2C2.xaxis) # ang between X1-X2
				mover=true				
				if ang.abs<precision or ang.abs>PI-precision # not move if ang =0 or 180 (aligned on X1-X2)
					if flip == flip1 # not move if matched flips
						if (delta-delta1).abs<precision # not move if matched deltas
							mover=false if (alfa-alfa1).abs<precision # not move if matched alfas
						end
					end
				end
				alignC1(c1, @j1, @j2, delta1,alfa1,flip1) if mover
			end
		end
	end
	c1.definition.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec2(filho,c1)
		end
	end
end

def self.alignC1(c1, j1, j2, delta,alfa,flip)
	precision=0.0001
	t_J1C1=j1.transformation
	t_J2C2=j2.transformation		
	#################################
	# Parte1: Alinhar J1-J2 com parametros [ 0.0, 0.0, false ]
	#################################
	#
	# alinhamento O1-O2 --------------------------------------------------------------
	t_C1C2=c1.transformation # transf da C1 em relacao a C2 (necessario nova cada vez que C1 muda de lugar)
	transf=Geom::Transformation.translation((t_C1C2*t_J1C1.origin).vector_to(t_J2C2.origin))
	c1.transform!(transf)
	# alinhamento X1-X2 ----------------------------------------------------------
	t_C1C2=c1.transformation # transf da C1 em relacao a C2 (necessario nova cada vez que C1 muda de lugar)
	x_J1C2=t_C1C2*t_J1C1.xaxis # J1(x) em relacao a C2
	ang=x_J1C2.angle_between(t_J2C2.xaxis)
	if ang.abs>precision
		if ang.abs>PI-precision # use local Z2 case ang=180
			v=t_J2C2.zaxis
		else
			v=(t_C1C2*t_J1C1.xaxis)*t_J2C2.xaxis # vector normal these 2 axis ... to accept signal of ang
		end
		transf=Geom::Transformation.rotation(t_J2C2.origin,v,ang)
		c1.transform!(transf)
	end
	# alinhamento Y1-Y2 ------------------------------------------------------------------
	t_C1C2=c1.transformation # transf da C1 em relacao a C2 (necessario nova cada vez que C1 muda de lugar)
	ang=(t_C1C2 * t_J1C1.yaxis).angle_between(t_J2C2.yaxis)
	if ang.abs>precision
		if ang.abs>PI-precision # use local X2 case ang=180
			v=t_J2C2.xaxis
		else
			v=(t_C1C2*t_J1C1.yaxis)*t_J2C2.yaxis # vector normal these 2 axis ... to accept signal of ang
		end
		transf=Geom::Transformation.rotation(t_J2C2.origin,v,ang)		
		c1.transform!(transf)
	end
	#################################
	# Parte2: Transformar com parametros [ delta, alfa, flip ]
	#################################
	#------------------------------------- delta
	if delta.abs>precision
		vetorX=t_J2C2.xaxis.clone
		vetorX.length=delta.abs
		if delta<0.0
			transf=Geom::Transformation.translation(vetorX.reverse)
		else
			transf=Geom::Transformation.translation(vetorX)
		end
		c1.transform!(transf)
	end
	#-------------------------------------------- alfa
	if alfa.abs>precision # rotation on J2(X)
		transf=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.xaxis,alfa)
		c1.transform!(transf)
	end
	#-------------------------------------------- flip
	if flip
		t_C1C2=c1.transformation # transf da C1 em relacao a C2
		t_C2J2=t_J2C2.inverse
		ptX=(t_C2J2 * t_C1C2 * t_J1C1.origin).x
		v=t_J2C2.xaxis.clone
		v.length=2.0*ptX
		t6=Geom::Transformation.translation(v)
		transf=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.zaxis,PI)
		c1.transform!(transf)
		c1.transform!(t6)
	end
end

def self.cleanDictionaries
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec1(filho,nil)
		end
	end
end
def self.filhosExec1(c1,c2)
	# check each JointSU dictionary that C1 has.
	# if corresponding J1/J2 are not found, delete the dictionary
	# if found, show (visible) corresponding J1.
	if c1.definition.name !="JointSU"
		dic_list=c1.attribute_dictionaries
		if dic_list !=nil
			dic_list.each do |d|
				if d.name[0,7]=="JointSU" # if C1 has a dictionary for J1, check if J1 and J2 are valid
					if c2==nil
						c1.delete_attribute(d.name)				
					else
						# part1: Check if J1 is valid
						@j1=nil				
						c1.definition.entities.each do |j|
							if j.typename=="ComponentInstance"
								if j.definition.name=="JointSU"
									if j.name==d.name[7,99]	
										@j1=j
										break
									end
								end
							end
						end
						if @j1 ==nil # if C1 has a valid J1 check it has a valid J2, otherwise delete the dict for J1
							c1.delete_attribute(d.name)	
						else
							j2=false
							c2.definition.entities.each do |j|
								if j.typename=="ComponentInstance"
									if j.definition.name=="JointSU"
										if j.name==d["Joint2"]
											j2=true
											break
										end
									end
								end
							end
							if j2
								@j1.hidden=false # ok. show J1
								d["Translation"]=0.0 if "#{d["Translation"].class}"=="NilClass" 
								d["Rotation"]=0.0 if d["Rotation"]==nil
								d["Flip"]=false if d["Flip"] != true and d["Flip"] != false
								d["Animation"]=false if d["Animation"] != true and d["Animation"] != false
								d["Step"]=0.0 if d["Step"]==nil								
							else
								c1.delete_attribute(d.name)	
							end
						end
					end
				end
			end
		end		
	end
	c1.definition.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec1(filho,c1)
		end
	end
end

def self.createGeoForJointSU(k)
	compo=Sketchup.active_model.definitions.add ("JointSU")
	compo.entities.add_cline([0,0,0],[5*k,0,0])
	compo.entities.add_face([0,-k,0],[k,0,0],[0,k,0])
	compo.entities.add_face([0,0,k],[0,0,0],[k,0,0])
	compo.entities.add_face([0,-k,0],[0,0,k],[0,k,0])
end

def self.explode(valor)
	@explodeValor=valor
	while Sketchup.active_model.close_active; end # set path at Model level
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec3(filho,nil,valor)
		end
	end
end
def self.filhosExec3(c1,c2,valor)
	dic_list=c1.attribute_dictionaries
	if dic_list !=nil
		dic_list.each do |d|
			if d.name[0,7]=="JointSU" # if C1 has a dictionary for J1 ...
				c1.definition.entities.each do |j|
					if j.typename=="ComponentInstance"
						if j.definition.name=="JointSU"
							if j.name==d.name[7,99]
								@j1=j
								c2.definition.entities.each do |k|
									if k.typename=="ComponentInstance"
										if k.definition.name=="JointSU"
											if k.name==d["Joint2"]
												@j2=k
												@explodeValor=0.9*@explodeValor
												v=@j2.transformation.xaxis.clone
												v.length=valor
												v.length=@explodeValor
												c1.transform!(Geom::Transformation.translation(v))
												break
											end
										end
									end
								end								
								break
							end
						end
					end
				end
			end
		end
	end
	c1.definition.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec3(filho,c1,valor)
		end
	end
end

def self.animation
	while Sketchup.active_model.close_active; end # set path at Model level
	kine=[]
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec4(filho,nil,kine)
		end
	end
	kine
end
def self.filhosExec4(c1,c2,kine)
	dic_list=c1.attribute_dictionaries
	if dic_list !=nil
		dic_list.each do |d|
			if d.name[0,7]=="JointSU" # if C1 has a dictionary for J1 ...
				delta1=d["Translation"]
				alfa1=d["Rotation"]
				flip1=d["Flip"]
				achou=false				
				c1.definition.entities.each do |j|
					if j.typename=="ComponentInstance"
						if j.definition.name=="JointSU"
							if j.name==d.name[7,99]
								achou=true
								break
							end
						end
					end
				end
				if achou
					@j2=nil
					c2.definition.entities.each do |j|
						if j.typename=="ComponentInstance"
							if j.definition.name=="JointSU"
								if j.name==d["Joint2"]
									@j2=j
									break
								end
							end
						end
					end
					if @j2 !=nil
						if d["Animation"]
							t_J2C2=@j2.transformation
							t=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.xaxis,d["Step"]) # torcao positiva
							kine<<[c1,t]
						end
					end
				end
			end
		end
	end
	c1.definition.entities.each do |filho|
		filhosExec4(filho,c1,kine) if filho.typename=="ComponentInstance"
	end
end

def self.checkProbOnAxes
	probs=[]
	while Sketchup.active_model.close_active; end # set path at Model level
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhosExec5(filho,probs)
		end
	end
	probs
end
def self.filhosExec5(c1,probs)
	r=checkAxesBase(c1)
	probs<<[c1,r[1],r[2],r[3]] if r[0]
	c1.definition.entities.each do |filho|
		filhosExec5(filho,probs) if filho.typename=="ComponentInstance"
	end
end
def self.checkAxesBase(c)
	precision=0.00001
	resp=false
	t=c.transformation
	e1=PI/2.0 - (t.xaxis).angle_between(t.yaxis)
	if e1<precision
		e1=0
	else
		resp=true
	end
	e2=PI/2.0 - (t.yaxis).angle_between(t.zaxis)
	if e2<precision
		e2=0
	else
		resp=true
	end
	e3=PI/2.0 - (t.zaxis).angle_between(t.xaxis)
	if e3<precision
		e3=0
	else
		resp=true
	end
	[resp,e1,e2,e3]
end
end # module